summaryrefslogtreecommitdiff
path: root/test
diff options
context:
space:
mode:
Diffstat (limited to 'test')
-rw-r--r--test/integration/Packages-xorg-break-providers52
-rw-r--r--test/integration/status-xorg-break-providers22
-rwxr-xr-xtest/integration/test-bug-590438-broken-provides-thanks-to-remove-order4
-rwxr-xr-xtest/integration/test-bug-595691-empty-and-broken-archive-files159
-rwxr-xr-xtest/integration/test-bug-601016-description-translation91
-rwxr-xr-xtest/integration/test-xorg-break-providers43
-rw-r--r--test/libapt/getlanguages_test.cc24
-rwxr-xr-xtest/libapt/run-tests2
-rwxr-xr-xtest/test-indexes.sh8
-rw-r--r--test/versions.lst1
10 files changed, 351 insertions, 55 deletions
diff --git a/test/integration/Packages-xorg-break-providers b/test/integration/Packages-xorg-break-providers
new file mode 100644
index 000000000..f6e1d81f9
--- /dev/null
+++ b/test/integration/Packages-xorg-break-providers
@@ -0,0 +1,52 @@
+Package: xserver-xorg-video-intel
+Priority: optional
+Section: x11
+Installed-Size: 1292
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Architecture: i386
+Version: 2:2.13.901-2
+Provides: xserver-xorg-video-8
+Filename: pool/main/x/xserver-xorg-video-intel/xserver-xorg-video-intel_2.13.901-2_i386.deb
+Size: 586964
+MD5sum: 72527f4b2c9d734e53202736e3177865
+Description: X.Org X server -- Intel i8xx, i9xx display driver
+
+Package: xserver-xorg-video-vesa
+Priority: optional
+Section: x11
+Installed-Size: 104
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Architecture: i386
+Version: 1:2.3.0-4
+Provides: xserver-xorg-video-8
+Filename: pool/main/x/xserver-xorg-video-vesa/xserver-xorg-video-vesa_2.3.0-4_i386.deb
+Size: 27158
+MD5sum: 77bf2935c40b3b7739d431930e53d185
+Description: X.Org X server -- VESA display driver
+
+Package: xserver-xorg-video-vesa
+Priority: optional
+Section: x11
+Installed-Size: 104
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Architecture: i386
+Version: 1:2.3.0-3
+Provides: xserver-xorg-video-6
+Filename: pool/main/x/xserver-xorg-video-vesa/xserver-xorg-video-vesa_2.3.0-3_i386.deb
+Size: 27122
+MD5sum: 0cd97be927c7d75f2a7230739f8f866c
+Description: X.Org X server -- VESA display driver
+
+Package: xserver-xorg-core
+Priority: optional
+Section: x11
+Installed-Size: 4436
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Architecture: i386
+Source: xorg-server
+Version: 2:1.7.7-8
+Breaks: xserver-xorg-video-6
+Filename: pool/main/x/xorg-server/xserver-xorg-core_1.7.7-8_i386.deb
+Size: 2405050
+MD5sum: 976ddb13473e52903dd839d1f7ec390b
+Description: Xorg X server - core server
diff --git a/test/integration/status-xorg-break-providers b/test/integration/status-xorg-break-providers
new file mode 100644
index 000000000..c6373518f
--- /dev/null
+++ b/test/integration/status-xorg-break-providers
@@ -0,0 +1,22 @@
+Package: xserver-xorg-core
+Status: install ok installed
+Priority: optional
+Section: x11
+Installed-Size: 4436
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Architecture: i386
+Source: xorg-server
+Version: 2:1.7.7-8
+Breaks: xserver-xorg-video-5
+Description: Xorg X server - core server
+
+Package: xserver-xorg-video-intel
+Status: install ok installed
+Priority: optional
+Section: x11
+Installed-Size: 1268
+Maintainer: Debian X Strike Force <debian-x@lists.debian.org>
+Architecture: i386
+Version: 2:2.13.0-2
+Provides: xserver-xorg-video-6
+Description: X.Org X server -- Intel i8xx, i9xx display driver
diff --git a/test/integration/test-bug-590438-broken-provides-thanks-to-remove-order b/test/integration/test-bug-590438-broken-provides-thanks-to-remove-order
index 3be0bec48..0f6493948 100755
--- a/test/integration/test-bug-590438-broken-provides-thanks-to-remove-order
+++ b/test/integration/test-bug-590438-broken-provides-thanks-to-remove-order
@@ -25,7 +25,7 @@ MD5sum: 8489687ce10e656babd467c9ee389349
Description-de: Verschiedene Dateien für das Basis-System von Debian"
predependsgawk() {
-# rm rootdir/var/cache/apt/*.bin
+ rm rootdir/var/cache/apt/*.bin
cp $TESTDIR/$(echo "$(basename $0)" | sed 's/test-/status-/') rootdir/var/lib/dpkg/status
echo "$pkgbasefile
Pre-Depends: $1
@@ -57,7 +57,7 @@ predependsgawk "awk | aawk"
predependsgawk "awk"
predependsgawk2() {
-# rm rootdir/var/cache/apt/*.bin
+ rm rootdir/var/cache/apt/*.bin
cp $TESTDIR/$(echo "$(basename $0)" | sed 's/test-/status-/') rootdir/var/lib/dpkg/status
echo "$pkgbasefile
Pre-Depends: $1
diff --git a/test/integration/test-bug-595691-empty-and-broken-archive-files b/test/integration/test-bug-595691-empty-and-broken-archive-files
index 2f127221a..11a5025d2 100755
--- a/test/integration/test-bug-595691-empty-and-broken-archive-files
+++ b/test/integration/test-bug-595691-empty-and-broken-archive-files
@@ -10,6 +10,7 @@ buildaptarchive
setupflataptarchive
testaptgetupdate() {
+ rm -rf rootdir/var/lib/apt rootdir/var/cache/apt
aptget update 2>> testaptgetupdate.diff >> testaptgetupdate.diff || true
sed -i -e '/^Fetched / d' -e 's#\[[0-9]* [kMGTPY]*B\]#\[\]#' testaptgetupdate.diff
GIVEN="$1"
@@ -23,69 +24,125 @@ testaptgetupdate() {
rm testaptgetupdate.diff
}
-touch aptarchive/en.bz2
+createemptyarchive() {
+ find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
+ if [ "en" = "$1" ]; then
+ echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
+ fi
+ touch aptarchive/Packages
+ echo -n "" | $COMPRESSOR > aptarchive/${1}.$COMPRESS
+ aptftparchive release aptarchive/ > aptarchive/Release
+ signreleasefiles
+ rm -f aptarchive/Packages
+}
-testaptgetupdate "Ign file: Release.gpg
-Ign file:$(readlink -f aptarchive)/ Translation-en
-Get:1 file: Release []
-Reading package lists..." "empty file en.bz2 over file"
+createemptyfile() {
+ find aptarchive/ \( -name "Packages*" -o -name "en*" \) -type f -delete
+ if [ "en" = "$1" ]; then
+ echo -n "" | $COMPRESSOR > aptarchive/Packages.$COMPRESS
+ fi
+ touch aptarchive/Packages aptarchive/${1}.$COMPRESS
+ aptftparchive release aptarchive/ > aptarchive/Release
+ signreleasefiles
+ rm -f aptarchive/Packages
+}
-rm aptarchive/en.bz2
-echo -n "" | bzip2 > aptarchive/en.bz2
+setupcompressor() {
+ COMPRESSOR="$1"
+ case $COMPRESSOR in
+ gzip) COMPRESS="gz";;
+ bzip2) COMPRESS="bz2";;
+ lzma) COMPRESS="lzma";;
+ esac
+ echo "Acquire::CompressionTypes::Order { \"${COMPRESS}\"; };
+Dir::Bin::gzip \"/does/not/exist\";
+Dir::Bin::bzip2 \"/does/not/exist\";
+Dir::Bin::lzma \"/does/not/exist\";" > rootdir/etc/apt/apt.conf.d/00compressor
+ if [ -e "/bin/${COMPRESSOR}" ]; then
+ echo "Dir::Bin::${COMPRESSOR} \"/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
+ elif [ -e "/usr/bin/${COMPRESSOR}" ]; then
+ echo "Dir::Bin::${COMPRESSOR} \"/usr/bin/${COMPRESSOR}\";" >> rootdir/etc/apt/apt.conf.d/00compressor
+ else
+ msgtest "Test for availability of compressor" "${COMPRESSOR}"
+ msgfail
+ exit 1
+ fi
+}
-testaptgetupdate "Ign file: Release.gpg
-Get:1 file: Release []
-Reading package lists..." "empty archive en.bz2 over file"
+testoverfile() {
+ setupcompressor "$1"
-rm aptarchive/en.bz2
+ createemptyfile 'en'
+ testaptgetupdate "Get:1 file: Release.gpg []
+Get:2 file: Release []
+Ign file:$(readlink -f aptarchive)/ Translation-en
+Reading package lists..." "empty file en.$COMPRESS over file"
+
+ createemptyarchive 'en'
+ testaptgetupdate "Get:1 file: Release.gpg []
+Get:2 file: Release []
+Reading package lists..." "empty archive en.$COMPRESS over file"
+
+ createemptyarchive 'Packages'
+ # FIXME: Why omits the file transport the Packages Get line?
+ #Get:3 file: Packages []
+ testaptgetupdate "Ign file:$(readlink -f aptarchive)/ Translation-en
+Get:1 file: Release.gpg []
+Get:2 file: Release []
+Reading package lists..." "empty archive Packages.$COMPRESS over file"
+
+ createemptyfile 'Packages'
+ testaptgetupdate "Ign file:$(readlink -f aptarchive)/ Translation-en
+Get:1 file: Release.gpg []
+Get:2 file: Release []
+Err file: Packages
+ Undetermined Error
+W: Failed to fetch file:$(readlink -f aptarchive/Packages.$COMPRESS) Undetermined Error
-# do the same again with http instead of file
-changetowebserver
+E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over file"
+}
-touch aptarchive/en.bz2
+testoverhttp() {
+ setupcompressor "$1"
-testaptgetupdate "Ign http://localhost Release.gpg
-Get:1 http://localhost/ Translation-en
-Get:2 http://localhost Release []
+ createemptyfile 'en'
+ testaptgetupdate "Get:1 http://localhost Release.gpg []
+Get:2 http://localhost/ Translation-en
+Get:3 http://localhost Release []
+Ign http://localhost/ Translation-en
+Get:4 http://localhost Packages []
+Reading package lists..." "empty file en.$COMPRESS over http"
+
+ createemptyarchive 'en'
+ testaptgetupdate "Get:1 http://localhost Release.gpg []
+Get:2 http://localhost/ Translation-en []
+Get:3 http://localhost Release []
+Get:4 http://localhost Packages []
+Reading package lists..." "empty archive en.$COMPRESS over http"
+
+ createemptyarchive 'Packages'
+ testaptgetupdate "Get:1 http://localhost Release.gpg []
Ign http://localhost/ Translation-en
-Get:3 http://localhost Packages []
-Reading package lists..." "empty file en.bz2 over http"
-
-rm aptarchive/en.bz2
-echo -n "" | bzip2 > aptarchive/en.bz2
-
-testaptgetupdate "Ign http://localhost Release.gpg
-Get:1 http://localhost/ Translation-en []
Get:2 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
Get:3 http://localhost Packages []
-Reading package lists..." "empty archive en.bz2 over http"
-
-rm aptarchive/en.bz2
-
-rm aptarchive/Packages
-touch aptarchive/Packages
-buildaptarchivefromfiles
-
-testaptgetupdate "Ign http://localhost Release.gpg
-Ign http://localhost/ Translation-en
-Get:1 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
-Get:2 http://localhost Packages []
-Reading package lists..." "empty archive Packages over http"
-
-find aptarchive/ -name 'Packages*' -type f -delete
-touch aptarchive/Packages.bz2
-aptftparchive release aptarchive/ > aptarchive/Release
+Reading package lists..." "empty archive Packages.$COMPRESS over http"
-#FIXME: we should response with a good error message instead
-testaptgetupdate "Ign http://localhost Release.gpg
+ createemptyfile 'Packages'
+ #FIXME: we should response with a good error message instead
+ testaptgetupdate "Get:1 http://localhost Release.gpg []
Ign http://localhost/ Translation-en
-Get:1 http://localhost Release []
-Ign http://localhost Packages/DiffIndex
-Get:2 http://localhost Packages
+Get:2 http://localhost Release []
+Get:3 http://localhost Packages
Err http://localhost Packages
Undetermined Error
-W: Failed to fetch http://localhost:8080/Packages.bz2 Undetermined Error
+W: Failed to fetch http://localhost:8080/Packages.$COMPRESS Undetermined Error
+
+E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages.$COMPRESS over http"
+}
+
+for COMPRESSOR in 'gzip' 'bzip2' 'lzma'; do testoverfile $COMPRESSOR; done
+
+# do the same again with http instead of file
+changetowebserver
-E: Some index files failed to download, they have been ignored, or old ones used instead." "empty file Packages over http"
+for COMPRESSOR in 'gzip' 'bzip2' 'lzma'; do testoverhttp $COMPRESSOR; done
diff --git a/test/integration/test-bug-601016-description-translation b/test/integration/test-bug-601016-description-translation
new file mode 100755
index 000000000..a31e42ee1
--- /dev/null
+++ b/test/integration/test-bug-601016-description-translation
@@ -0,0 +1,91 @@
+#!/bin/sh
+set -e
+
+TESTDIR=$(readlink -f $(dirname $0))
+. $TESTDIR/framework
+setupenvironment
+configarchitecture "i386"
+
+# we need a valid locale here, otherwise the language configuration
+# will be overridden by LC_ALL=C
+LOCALE="$(echo "$LANG" | cut -d'_' -f 1)"
+
+PACKAGESTANZA="Package: apt
+Priority: important
+Section: admin
+Installed-Size: 5984
+Maintainer: APT Development Team <deity@lists.debian.org>
+Architecture: i386
+Version: 0.8.7
+Filename: pool/main/a/apt/apt_0.8.7_i386.deb
+Size: 2140230
+MD5sum: 74769bfbcef9ebc4fa74f7a5271b9c08
+Description-md5: d41ee493aa9fcc6cbc9ce4eb7069959c"
+
+
+echo "$PACKAGESTANZA
+Description: Advanced front-end for dpkg" > aptarchive/Packages
+
+echo "Package: apt
+Description-md5: d41ee493aa9fcc6cbc9ce4eb7069959c
+Description-${LOCALE}: Mächtige Oberfläche für dpkg
+ Das Paket bietet dem Nutzer technisch führende Methoden für den Zugriff
+ auf den dpkg-Paketmanager. Es beinhaltet das apt-get-Werkzeug und die
+ APT-Dselect-Methode. Beides sind einfache und sicherere Wege,
+ um Pakete zu installieren und Upgrades durchzuführen." | bzip2 > aptarchive/${LOCALE}.bz2
+
+# the $LOCALE translation file will not be included as it is a flat archive it came from and therefore
+# its name can not be guessed correctly… (in non-flat archives the files are called Translation-*)
+echo 'APT::Cache::Generate "false";' > rootdir/etc/apt/apt.conf.d/00nogenerate
+
+NOLONGSTANZA="$PACKAGESTANZA
+Description: Advanced front-end for dpkg
+"
+
+ENGLISHSTANZA="$PACKAGESTANZA
+Description: Advanced front-end for dpkg
+"
+
+LOCALESTANZA="$PACKAGESTANZA
+Description-${LOCALE}: Mächtige Oberfläche für dpkg
+ Das Paket bietet dem Nutzer technisch führende Methoden für den Zugriff
+ auf den dpkg-Paketmanager. Es beinhaltet das apt-get-Werkzeug und die
+ APT-Dselect-Methode. Beides sind einfache und sicherere Wege,
+ um Pakete zu installieren und Upgrades durchzuführen.
+"
+
+testrun() {
+ echo "Acquire::Languages { \"${LOCALE}\"; \"en\"; };" > rootdir/etc/apt/apt.conf.d/00languages
+ export LC_ALL=""
+ setupaptarchive
+ testequal "$LOCALESTANZA" aptcache show apt -o Test=File-${LOCALE}
+ testequal "$NOLONGSTANZA" aptcache show apt -o Acquire::Languages="ww" -o Test=File-${LOCALE}
+ testequal "$LOCALESTANZA" aptcache show apt -o Acquire::Languages::="ww" -o Test=File-${LOCALE}
+ LC_ALL=C testequal "$ENGLISHSTANZA" aptcache show apt -o Test=File-${LOCALE}
+ export LC_ALL=""
+ echo "Acquire::Languages { \"ww\"; \"${LOCALE}\"; \"en\"; };" > rootdir/etc/apt/apt.conf.d/00languages
+ testequal "$LOCALESTANZA" aptcache show apt -o Test=File-ww-${LOCALE}
+ echo "Acquire::Languages { \"ww\"; \"en\"; };" > rootdir/etc/apt/apt.conf.d/00languages
+ testequal "$ENGLISHSTANZA" aptcache show apt -o Test=File-ww
+}
+
+testrun
+
+echo "$PACKAGESTANZA
+Description: Advanced front-end for dpkg" > aptarchive/Packages
+
+echo "Package: apt
+Description-md5: d41ee493aa9fcc6cbc9ce4eb7069959c
+Description-en: Advanced front-end for dpkg
+ This is Debian's next generation front-end for the dpkg package manager.
+ It provides the apt-get utility and APT dselect method that provides a
+ simpler, safer way to install and upgrade packages." | bzip2 > aptarchive/en.bz2
+
+ENGLISHSTANZA="$PACKAGESTANZA
+Description-en: Advanced front-end for dpkg
+ This is Debian's next generation front-end for the dpkg package manager.
+ It provides the apt-get utility and APT dselect method that provides a
+ simpler, safer way to install and upgrade packages.
+"
+
+testrun
diff --git a/test/integration/test-xorg-break-providers b/test/integration/test-xorg-break-providers
new file mode 100755
index 000000000..139d2c915
--- /dev/null
+++ b/test/integration/test-xorg-break-providers
@@ -0,0 +1,43 @@
+#!/bin/sh
+set -e
+
+TESTDIR=$(readlink -f $(dirname $0))
+. $TESTDIR/framework
+setupenvironment
+configarchitecture "i386"
+setupaptarchive
+
+# the new xserver-xorg-core breaks xserver-xorg-video-6
+# which both -intel (installed) and -vesa (not installed)
+# provided in their old version.
+# The test ensures that only -intel will be upgraded
+# (together with -core of course) and -vesa not touched.
+
+testequal 'Reading package lists...
+Building dependency tree...
+The following extra packages will be installed:
+ xserver-xorg-video-intel
+The following packages will be upgraded:
+ xserver-xorg-core xserver-xorg-video-intel
+2 upgraded, 0 newly installed, 0 to remove and 0 not upgraded.
+Need to get 0 B/2992 kB of archives.
+After this operation, 24.6 kB of additional disk space will be used.
+E: Trivial Only specified but this is not a trivial operation.' aptget install xserver-xorg-core --trivial-only
+
+testequal 'Reading package lists...
+Building dependency tree...
+The following packages will be upgraded:
+ xserver-xorg-core xserver-xorg-video-intel
+2 upgraded, 0 newly installed, 0 to remove and 0 not upgraded.
+Need to get 0 B/2992 kB of archives.
+After this operation, 24.6 kB of additional disk space will be used.
+E: Trivial Only specified but this is not a trivial operation.' aptget upgrade --trivial-only
+
+testequal 'Reading package lists...
+Building dependency tree...
+The following packages will be upgraded:
+ xserver-xorg-core xserver-xorg-video-intel
+2 upgraded, 0 newly installed, 0 to remove and 0 not upgraded.
+Need to get 0 B/2992 kB of archives.
+After this operation, 24.6 kB of additional disk space will be used.
+E: Trivial Only specified but this is not a trivial operation.' aptget dist-upgrade --trivial-only
diff --git a/test/libapt/getlanguages_test.cc b/test/libapt/getlanguages_test.cc
index 9a8910b58..3559aae0c 100644
--- a/test/libapt/getlanguages_test.cc
+++ b/test/libapt/getlanguages_test.cc
@@ -85,6 +85,30 @@ int main(int argc,char *argv[])
equals(vec.size(), 1);
equals(vec[0], "en");
+ _config->Set("Acquire::Languages", "none");
+ env[0] = "C";
+ vec = APT::Configuration::getLanguages(false, false, env);
+ equals(vec.size(), 0);
+
+ _config->Set("Acquire::Languages", "environment");
+ env[0] = "C";
+ vec = APT::Configuration::getLanguages(false, false, env);
+ equals(vec.size(), 1);
+ equals(vec[0], "en");
+
+ _config->Set("Acquire::Languages", "de");
+ env[0] = "C";
+ vec = APT::Configuration::getLanguages(false, false, env);
+ equals(vec.size(), 1);
+ equals(vec[0], "de");
+
+ _config->Set("Acquire::Languages", "fr");
+ env[0] = "ast_DE.UTF-8";
+ vec = APT::Configuration::getLanguages(false, false, env);
+ equals(vec.size(), 1);
+ equals(vec[0], "fr");
+ _config->Set("Acquire::Languages", "");
+
_config->Set("Acquire::Languages::1", "environment");
_config->Set("Acquire::Languages::2", "en");
env[0] = "de_DE.UTF-8";
diff --git a/test/libapt/run-tests b/test/libapt/run-tests
index 0f55f7386..f5fc03446 100755
--- a/test/libapt/run-tests
+++ b/test/libapt/run-tests
@@ -4,7 +4,7 @@ set -e
local DIR=$(readlink -f $(dirname $0))
echo "Compiling the tests …"
test -d "$DIR/../../build/obj/test/libapt/" || mkdir -p "$DIR/../../build/obj/test/libapt/"
-$(cd $DIR && make)
+(cd $DIR && make)
echo "Running all testcases …"
LDPATH="$DIR/../../build/bin"
EXT="_libapt_test"
diff --git a/test/test-indexes.sh b/test/test-indexes.sh
index dad3e1fb2..17363718d 100755
--- a/test/test-indexes.sh
+++ b/test/test-indexes.sh
@@ -135,6 +135,14 @@ echo "deb-src $TEST_SOURCE" >> etc/apt/sources.list
echo "RootDir \"$WORKDIR\";" > apt_config
export APT_CONFIG=`pwd`/apt_config
+echo "==== no indexes ===="
+echo '--- apt-get check works without indexes'
+[ -z `$APT_GET check` ]
+echo '--- apt-cache policy works without indexes'
+$APT_CACHE policy bash >/dev/null
+echo '--- apt-cache show works without indexes'
+! LC_MESSAGES=C $APT_CACHE show bash 2>&1| grep -q 'E: No packages found'
+
echo "===== uncompressed indexes ====="
check_update
check_indexes
diff --git a/test/versions.lst b/test/versions.lst
index 517214151..2d0967645 100644
--- a/test/versions.lst
+++ b/test/versions.lst
@@ -104,4 +104,3 @@ III-alpha9.8 III-alpha9.8-1.5 -1
1.4+OOo3.0.0~ 1.4+OOo3.0.0-4 -1 # another tilde check
2.4.7-1 2.4.7-z -1 # revision comparing
1.002-1+b2 1.00 1 # whatever...
-2.2.4-47978_Debian_lenny 2.2.4-47978_Debian_lenny 0 # and underscore...